using System;
using System.Collections.Generic;

namespace SlXnaAppMangoMotion
{
    /// <summary>
    /// IServiceProvider AvP[VɎ܂B̌^́AApp.Services vpeBʂČJA
    /// ContentManagers ȂǁAIServiceProvider ɃANZXKv^Ŏgpł܂B
    /// </summary>
    public class AppServiceProvider : IServiceProvider
    {
        // T[rX̂ɍsT[rX̌^̃}bv
        private readonly Dictionary<Type, object> services = new Dictionary<Type, object>();

        /// <summary>
        /// VT[rXT[rX voC_[ɒǉ܂B
        /// </summary>
        /// <param name="serviceType">ǉT[rX̌^B</param>
        /// <param name="service">T[rX IuWFNǵB</param>
        public void AddService(Type serviceType, object service)
        {
            // ͂؂܂
            if (serviceType == null)
                throw new ArgumentNullException("serviceType");
            if (service == null)
                throw new ArgumentNullException("service");
            if (!serviceType.IsAssignableFrom(service.GetType()))
                throw new ArgumentException("service does not match the specified serviceType");

            // T[rXfBNViɒǉ܂
            services.Add(serviceType, service);
        }

        /// <summary>
        /// T[rX voC_[T[rX擾܂B
        /// </summary>
        /// <param name="serviceType">擾T[rX̌^B</param>
        /// <returns>w̌^ɓo^ꂽT[rX IuWFNgB</returns>
        public object GetService(Type serviceType)
        {
            // ͂؂܂
            if (serviceType == null)
                throw new ArgumentNullException("serviceType");

            // fBNViT[rX擾܂
            return services[serviceType];
        }

        /// <summary>
        /// T[rX voC_[T[rX폜܂B
        /// </summary>
        /// <param name="serviceType">폜T[rX̌^B</param>
        public void RemoveService(Type serviceType)
        {
            // ͂؂܂
            if (serviceType == null)
                throw new ArgumentNullException("serviceType");

            // fBNViT[rX폜܂
            services.Remove(serviceType);
        }
    }
}
